Index: trunk/SophyaPI/PI/pidrawer.cc
===================================================================
--- trunk/SophyaPI/PI/pidrawer.cc	(revision 157)
+++ trunk/SophyaPI/PI/pidrawer.cc	(revision 158)
@@ -1,4 +1,31 @@
+// Module PI : Peida Interactive     PIDrawer
+// Classe de traceurs pouvat être attachés à une PIBaseWdg
+//	      E. Aubourg , R.Ansari     96-98
+// LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
+
 #include "pidrawer.h"
 #include "psfile.h"
+
+//++
+// Class	PIDrawer
+// Lib		PI
+// include	pidrawer.h
+//
+//	Classe pour la création d'objets, capables de se dessiner
+//	dans une composante graphique ("PIBaseWdg").
+//--
+//++
+// Links	Voir
+// PIBaseWdg
+//--
+
+//++
+// Titre	Constructeurs et méthodes
+//--
+
+//++
+// PIDawer()
+//	Constructeur.
+//--
 
 PIDrawer::PIDrawer()
@@ -32,4 +59,15 @@
 }
 
+//++
+// void  SetLimits(float xmin, float xmax, float ymin, float ymax, -
+//                 int axrl=kAxeDirSame, int ayud=kAxeDirSame)
+//	Définit les limites du système de coordonnées.
+// void  SetAxesFlags(unsigned int flags=kAxesNone)
+//	Attributs de tracé d'axes
+//|	kStdAxes , kBoxAxes , kTicks , kIntTicks , kExtTicks 
+//|	kMajTicks , kMinTicks , kLabels , kAxesDflt , kAxesNone
+// void  DrawAxes(PIGraphicUC* g)
+//	Méthode de tracé des axes
+//--
 
 void
@@ -62,4 +100,15 @@
 }
 
+//++
+//  void  Draw(PIGraphicUC* g, float xmin, float ymin, float xmax, float ymax)
+//	Méthode qui est appelé lorsquer l'objet PIDrawer doit rafraichir la zone
+//	définie par "xmin-xmax" , "ymin-ymax" dans le système de coordonnées du
+//	PIDrawer.
+//  void  Refresh()
+//	Rafraîchit le dessin du PIDrawer sur tous les PIBaseWdg auxquel il est attaché.
+//  void  UpdateLimits()
+//	Cette méthode doit calculer les limites (X/Y Min-Max) préferées par l'objet
+//	et doit appeler "SetLimits()". L'implementation par défaut ne fait rien.
+//--
 
 void
@@ -78,4 +127,23 @@
 
 }
+
+//++
+// Titre	Les attributs graphiques
+//--
+//++
+// void  SetColAtt(PIColors fg=PI_NotDefColor, PIColors bg=PI_NotDefColor)
+//	Modifie la couleur d'avant-plan et de fond par défaut
+// void  SetLineAtt(PILineAtt lat=PI_NotDefLineAtt)
+//	Modifie l'attribut type de ligne
+// void  SetFontAtt(PIFontSize fsz=PI_NotDefFontSize, PIFontAtt fat=PI_NotDefFontAtt)
+//	L'attribut Type de fonte 
+// void  SetMarkerAtt(int sz=-1, PIMarker mrk=PI_NotDefMarker)
+//	L'attribut type et taille de marker
+// void  SetColMapId(CMapId cid=CMAP_OTHER)
+//	L'attribut choix de la table de couleurs
+// void  SelGraAtt(PIGraphicUC* g)
+//	Modifie les attributs graphiques de "g" à partir des attributs courant
+//	de l'objet "PIDrawer"
+//--
 
 void 
@@ -384,4 +452,5 @@
 {
 mEn = 0;
+titleT = titleB = "";
 }
 
@@ -392,4 +461,17 @@
 
 /* --Methode-- */
+void PIElDrawer::SetTitles(const char* tt, const char* tb)
+{
+if (tt != NULL)  titleT = tt;
+if (tb != NULL)  titleB = tb;
+}
+
+/* --Methode-- */
+void PIElDrawer::SetTitles(string const & tt, string const & tb)
+{
+titleT = tt;  titleB = tb;
+}
+
+/* --Methode-- */
 void  PIElDrawer::Draw(PIGraphicUC* g, float /*xmin*/, float /*ymin*/, float /*xmax*/, float /*ymax*/)
 {
@@ -397,7 +479,37 @@
 
 SelGraAtt(g);   // DrawAxes change certains attributs graphiques
+if (mFSz == PI_NotDefFontSize) g->SelFont(PI_NormalSizeFont);
+// Trace des titres 
+if ( (titleT.length() > 0) || (titleB.length() > 0) ) {
+  aXdir = false;  // Vrai si Axe X de Droite vers Gauche 
+  aYdir = false;  // Vrai si Axe Y de Haut vers Bas
+  PIGrCoord gas, gds;
+  float fx, fy, fh;
+//  fh = g->GetFontHeightUC(gas, gds);
+  fh = 0.075*(YMax()-YMin());
+  if ( titleT.length() > 0) {
+      fx = g->CalcStringWidth(titleT.c_str());
+      if(aXdir) fx = XMax()-(XMax()-XMin()-fx)/2.;
+      else fx = XMin()+(XMax()-XMin()-fx)/2.;
+      if (aYdir) fy = YMin()-fh;
+      else fy = YMax()+fh;
+      g->DrawString(fx, fy, titleT.c_str());
+//      printf(" PIElDrawer::Draw()/DBG (%g , %g) %s  - %g \n", fx, fy, titleT.c_str(), fh);
+    }
+  if ( titleB.length() > 0) {
+      fx = g->CalcStringWidth(titleB.c_str());
+      if(aXdir) fx = XMax()-(XMax()-XMin()-fx)/2.;
+      else fx = XMin()+(XMax()-XMin()-fx)/2.;
+      if (aYdir) fy =  YMax()+fh*1.5;
+      else fy = YMin()-fh*1.5;
+      g->DrawString(fx, fy, titleB.c_str());
+//      printf(" PIElDrawer::Draw()/DBG (%g , %g) %s  - %g \n", fx, fy, titleT.c_str(), fh);
+    }
+  }
 DrwElList::iterator it;
+PIColors cc = g->GetForeground();
 for (it = mElist.begin(); it != mElist.end(); it++)
   {
+  if ((*it).col != PI_NotDefColor)  g->SelForeground((*it).col);
   switch ( (*it).etyp )
     {
@@ -423,10 +535,11 @@
       break;
     }
-  }
-}
-
-
-/* --Methode-- */
-int PIElDrawer::ElAdd(int typ, PIGrCoord x, PIGrCoord  y, PIGrCoord dx, PIGrCoord dy, char* s)
+  g->SelForeground(cc);
+  }
+}
+
+
+/* --Methode-- */
+int PIElDrawer::ElAdd(int typ, PIGrCoord x, PIGrCoord  y, PIGrCoord dx, PIGrCoord dy, const char* s, PIColors c)
 {
 DrwEl dre;
@@ -435,4 +548,5 @@
 dre.ex = x;   dre.ey = y;
 dre.edx = dx;  dre.edy = dy;
+dre.col = c;
 if (s)  dre.es = s;
 mElist.push_back(dre);
Index: trunk/SophyaPI/PI/pidrawer.h
===================================================================
--- trunk/SophyaPI/PI/pidrawer.h	(revision 157)
+++ trunk/SophyaPI/PI/pidrawer.h	(revision 158)
@@ -125,18 +125,24 @@
   virtual           ~PIElDrawer();
 
+  virtual void	     SetTitles(const char* tt=NULL, const char* tb=NULL);
+  virtual void       SetTitles(string const & tt, string const & tb);
+
   virtual void       Draw(PIGraphicUC* g, float xmin, float ymin, float xmax, float ymax); 
 
-  inline int         ElAddLine(PIGrCoord x1, PIGrCoord y1, PIGrCoord x2, PIGrCoord y2)
-    { return( ElAdd(PIDEL_Line, x1, y1, x2, y2, NULL) ); }  
-  inline int         ElAddText(PIGrCoord x, PIGrCoord y, char* s)
-    { return( ElAdd(PIDEL_Text, x, y, 0, 0, s) ); }  
-  inline int         ElAddRect(PIGrCoord x, PIGrCoord y, PIGrCoord dx, PIGrCoord dy)
-    { return( ElAdd(PIDEL_Rect, x, y, dx, dy, NULL) ); }  
-  inline int         ElAddFRect(PIGrCoord x, PIGrCoord y, PIGrCoord dx, PIGrCoord dy)
-    { return( ElAdd(PIDEL_FRect, x, y, dx, dy, NULL) ); }  
-  inline int         ElAddCirc(PIGrCoord x, PIGrCoord y, PIGrCoord r)
-    { return( ElAdd(PIDEL_Circ, x, y, r, r, NULL) ); }  
-  inline int         ElAddFCirc(PIGrCoord x, PIGrCoord y, PIGrCoord r)
-    { return( ElAdd(PIDEL_FCirc, x, y, r, r, NULL) ); }  
+  inline int         ElAddLine(PIGrCoord x1, PIGrCoord y1, PIGrCoord x2, PIGrCoord y2, 
+                               PIColors c=PI_NotDefColor)
+    { return( ElAdd(PIDEL_Line, x1, y1, x2, y2, NULL, c) ); }  
+  inline int         ElAddText(PIGrCoord x, PIGrCoord y, const char* s, PIColors c=PI_NotDefColor)
+    { return( ElAdd(PIDEL_Text, x, y, 0, 0, s, c) ); }  
+  inline int         ElAddRect(PIGrCoord x, PIGrCoord y, PIGrCoord dx, PIGrCoord dy, 
+                               PIColors c=PI_NotDefColor)
+    { return( ElAdd(PIDEL_Rect, x, y, dx, dy, NULL, c) ); }  
+  inline int         ElAddFRect(PIGrCoord x, PIGrCoord y, PIGrCoord dx, PIGrCoord dy,
+                               PIColors c=PI_NotDefColor)
+    { return( ElAdd(PIDEL_FRect, x, y, dx, dy, NULL, c) ); }  
+  inline int         ElAddCirc(PIGrCoord x, PIGrCoord y, PIGrCoord r, PIColors c=PI_NotDefColor)
+    { return( ElAdd(PIDEL_Circ, x, y, r, r, NULL, c) ); }  
+  inline int         ElAddFCirc(PIGrCoord x, PIGrCoord y, PIGrCoord r, PIColors c=PI_NotDefColor)
+    { return( ElAdd(PIDEL_FCirc, x, y, r, r, NULL, c) ); }  
 
   void               ElDel(int id);
@@ -144,5 +150,6 @@
 
 protected:
-  int                ElAdd(int typ, PIGrCoord x, PIGrCoord y, PIGrCoord dx, PIGrCoord dy, char* s);
+  int                ElAdd(int typ, PIGrCoord x, PIGrCoord y, PIGrCoord dx, PIGrCoord dy, 
+                           const char* s, PIColors c=PI_NotDefColor);
 #ifdef __DECCXX
 public:
@@ -153,4 +160,5 @@
     PIGrCoord edx,edy;
     string es;
+    PIColors col;
   };
 #ifdef __DECCXX
@@ -162,4 +170,6 @@
   int mEn;
 
+  string titleT, titleB;       // Titre Haut - Bas
+
 };
 
Index: trunk/SophyaPI/PI/pidrwtools.cc
===================================================================
--- trunk/SophyaPI/PI/pidrwtools.cc	(revision 157)
+++ trunk/SophyaPI/PI/pidrwtools.cc	(revision 158)
@@ -184,9 +184,12 @@
 mOpt[4]->AppendItem("Ital", 513);
 mOpt[4]->AppendItem("Small-Font", 521);
-mOpt[4]->AppendItem("Small-Bold-Font", 522);
-mOpt[4]->AppendItem("Small-Ital-Font", 523);
+mOpt[4]->AppendItem("Small-Bold", 522);
+mOpt[4]->AppendItem("Small-Ital", 523);
 mOpt[4]->AppendItem("Big-Font", 531);
 mOpt[4]->AppendItem("Big-Bold", 532);
 mOpt[4]->AppendItem("Big-Ital", 533);
+mOpt[4]->AppendItem("Huge-Font", 541);
+mOpt[4]->AppendItem("Huge-Bold", 542);
+mOpt[4]->AppendItem("Huge-Ital", 543);
 mOpt[4]->SetValue(500);
 mOpt[4]->SetBinding(PIBK_elastic, PIBK_elastic, PIBK_elastic, PIBK_elastic);
@@ -305,5 +308,6 @@
 
 PIFontAtt fntatt[4] = { PI_NotDefFontAtt, PI_RomanFont, PI_BoldFont, PI_ItalicFont };
-PIFontSize fntsz[4] = { PI_NotDefFontSize, PI_NormalSizeFont, PI_SmallSizeFont, PI_BigSizeFont };
+PIFontSize fntsz[5] = { PI_NotDefFontSize, PI_NormalSizeFont, PI_SmallSizeFont, 
+                        PI_BigSizeFont, PI_HugeSizeFont };
 CMapId cmap[11] = {  CMAP_OTHER, CMAP_GREY32, CMAP_GREYINV32,
                      CMAP_COLRJ32, CMAP_COLBR32, CMAP_COLRV32,  
Index: trunk/SophyaPI/PI/pigraph3d.cc
===================================================================
--- trunk/SophyaPI/PI/pigraph3d.cc	(revision 157)
+++ trunk/SophyaPI/PI/pigraph3d.cc	(revision 158)
@@ -6,4 +6,30 @@
 #include <math.h>
 #include "pigraph3d.h"
+
+//++
+// Class	PIGraphic3D
+// Lib		PI
+// include	pigraph3d.h
+//
+//   	Classe fournissant les services de tracé graphique 
+//	en coordonnées utilisateur, et quelques primitives de tracé 3D
+//--
+//++
+// Links	Parent
+// PIGraphicUC
+//--
+
+//++
+// Titre	Constructeurs, méthodes
+//--
+//++
+// PIGraphic3D(PIGraphicGen* g, PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy)
+//	Constructeur d'un objet "PIGraph3D" à partir d'un "PIGraphic* g". L'espace
+//	de travail du nouvel objet "PIGraphic" correspond au rectangle défini par
+//	"(x0,y0)" , "dx,dy" du "PIGraphic" de départ.
+// 
+// int  kind()
+//	Renvoie le type ("= PI_3DGraphics")
+//--
 
 /* --Methode-- */
@@ -33,4 +59,41 @@
   return PI_3DGraphics; 
 }
+
+//++
+// Titre	Système de coordonnées 3D et projection
+//	Le système de coordonnées 3D est défini par la position de l'observateur (caméra),
+//	la direction de visée ou la position du centre du champ, 
+//	l'ouverture angulaire de la caméra selon les deux 
+//	axes de la projection (X,Y), eventuellement un angle correspondant à la rotation
+//	du plan image ("psi"). Les angles d'Euler ("teta", "phi", "psi" ) sont utilisés
+//	dans la définition du système de coordonnées et la projection est de type 
+//	perspective. 
+//
+//	Les coordonnées utilisateur définissant le plan image ("PIGraphicUC") vont de 
+//	X: "-dax , +dax"   Y : "-day , +day".  
+//--
+
+//++
+// void  Set3DCS_Obs(float xo, float yo, float zo, float teta, float phi, float psi, -
+//                  float dax, float day, float co, float dco=0.2)
+//	Définition du système de projection 3D à l'aide de la position de l'observateur 
+//	et de la direction de visée.
+//|	xo,yo,zo : Position de l'observateur (camera)
+//|	teta,phi : Direction de visee
+//|	psi : rotation du plan image
+//|	dax , day : Ouverture du plan image selon les deux axes = Xmax,Ymax / Z
+//|	co : distance au centre du champ
+//|	dco : profondeur de champ 
+//
+// void  Set3DCS(float xc, float yc, float zc, float xo, float yo, float zo, -
+//               float dax, float day, float dco=0.2, float psi=0.)
+//	Définition du système de projection 3D à partir de la position de l'observateur et 
+//	du centre du champ.
+//|	xc,yc,zc : Position du centre du champ
+//|	xo,yo,zo : Position de l'observateur (camera)
+//|	dax , day : Ouverture du plan image selon les deux axes = Xmax,Ymax / Z
+//|	dco : profondeur de champ 
+//|	psi : rotation du plan image
+//--
 
 static float deuxpi = 2*M_PI;
@@ -128,4 +191,27 @@
 }
 
+//++
+// bool Get3DCS(float& xc, float& yc, float& zc, float& xo, float& yo, float& zo, -
+//             float& teta, float& phi, float& psi, float& dax, float& day, float& co, float& dco);
+//	Renvoie les paramètres de définition du système de projection 3D.
+//	"Rc= true" si défini par  "Set3DCS_Obs()"
+//	
+// void  RotateObserver(float teta, float phi, float psi=0., bool rel=true)
+//	Positionne l'observateur (la caméra) en maintenant la position  
+//	du centre de champ fixe. Si "rel=false" : "teta, phi" determine la nouvelle
+//	direction de visée. Si "rel=false" : la direction de visée est tournée
+//	de l'angle "teta,phi". 
+// void  RotateObject(float teta, float phi, bool rel=true)
+//	Repostionne le centre du champ en maintenant la position de l'observateur fixe.
+//	Si "rel=false" : "teta, phi" determine la nouvelle direction de visée.
+//	Si "rel=false" : la direction de visée est tournée de l'angle "teta,phi". 
+// 
+// void  ZoomInOut(float fco, float fdax, float fday, bool rel=true)
+//	Eloigne ou approche l'observateur et modifie l'ouverture du plan image.
+//	si "real=true" : "fco, fdax, fday" sont des facteurs multiplicatifs
+//	par rapport aux valeurs actuelles, sinon des valeurs absolues. 
+//|	fco : distance observateur - centre du champ
+//|	fdax, fday : ouverture du plan image
+//--
 
 /* --Methode-- */
@@ -141,4 +227,232 @@
 }
 
+
+/* --Methode-- */
+void PIGraphic3D::RotateObserver(float teta, float phi, float psi, bool rel)
+// Positionne l'observateur (la camera) de maniere a ce que la direction de 
+// visee soit tO=teta, pO=phi (rel=false) / tO+=teta pO+=phi (rel=true) 
+// en conservant le centre de champ fixe  
+{
+  if (rel) {
+    teta += tO;
+    phi += fO;
+    psi += pO;
+    }
+  while (teta < 0.)  teta += deuxpi;
+  while (teta > deuxpi)  teta -= deuxpi;
+  if (teta > M_PI)  { teta = M_PI-teta;  phi = phi+M_PI; }
+  float xo,yo,zo; 
+  zo = -cos((double)teta)*lCO+zC;
+  xo = -sin((double)teta)*cos((double)phi)*lCO+xC;
+  yo = -sin((double)teta)*sin((double)phi)*lCO+yC;
+  Set3DCS(xC,yC,zC, xo,yo,zo, daxO, dayO, dlCO, psi);
+}
+
+/* --Methode-- */
+void PIGraphic3D::RotateObject(float teta, float phi, bool rel)
+// Positionne l'objet (centre du champ) de maniere a ce que la direction de 
+// visee soit tO=teta, pO=phi (rel=false) / tO+=teta pO+=phi (rel=true) 
+// en conservant la position de l'observateur fixe.  
+{
+  if (rel) {
+    teta += tO;
+    phi += fO;
+    }
+  while (teta < 0.)  teta += deuxpi;
+  while (teta > deuxpi)  teta -= deuxpi;
+  if (teta > M_PI)  { teta = M_PI-teta;  phi = phi+M_PI; }
+  float xc,yc,zc; 
+  zc = cos((double)teta)*lCO+zO;
+  xc = sin((double)teta)*cos((double)phi)*lCO+xO;
+  yc = sin((double)teta)*sin((double)phi)*lCO+yO;
+  Set3DCS(xc,yc,zc, xO,yO,zO, daxO, dayO, dlCO, pO);
+}
+
+/* --Methode-- */
+void PIGraphic3D::ZoomInOut(float fco, float fdax, float fday, bool rel)
+{
+  if (fco < 0.001) fco = 1.;
+  if (fdax < 0.001) fdax = 1.;
+  if (fday < 0.001) fday = 1.;
+  double dl;
+  if (rel) {
+    dl = fco*lCO;  
+    fdax *= daxO;
+    fday *= dayO;
+  }
+  else dl = fco; 
+  float xo,yo,zo; 
+  if (dl < 1.e-5) dl = 1.e-5;
+  zo = zC-cos((double)tO)*dl;
+  xo = xC-sin((double)tO)*cos((double)fO)*dl;
+  yo = yC-sin((double)tO)*sin((double)fO)*dl;
+  Set3DCS(xC,yC,zC, xo,yo,zo, fdax, fday, dlCO, pO);
+//  Set3DCS_Obs(xo, yo, zo, tO, fO, pO, daxO*fda, dayO*fda, dl, dlCO);
+}
+
+/* --Methode-- */
+void PIGraphic3D::C3DC2ObsCS(float x, float y, float z, float& xp, float& yp, float& zp)
+{
+  double xc, yc, zc;
+  xc = x-xO;   yc = y-yO;    zc = z-zO;
+  xp = RE[0][0]*xc+RE[0][1]*yc+RE[0][2]*zc;
+  yp = -RE[1][0]*xc+RE[1][1]*yc+RE[1][2]*zc;  
+  zp = RE[2][0]*xc+RE[2][1]*yc+RE[2][2]*zc;
+}
+
+/* --Methode-- */
+void PIGraphic3D::Proj3DC2GrC(float x, float y, float z, float& xpix, float& ypix)
+{
+  double xc, yc, zc;
+  float xp, yp, zp;
+  xc = x-xO;   yc = y-yO;    zc = z-zO;
+  xp = RE[0][0]*xc+RE[0][1]*yc+RE[0][2]*zc;   
+  yp = RE[1][0]*xc+RE[1][1]*yc+RE[1][2]*zc;
+  zp = RE[2][0]*xc+RE[2][1]*yc+RE[2][2]*zc;
+  if ((zp>-1.e-6) && (zp < 1.e-6))   // Protection Divide/0
+    { xpix = ypix = 0.;   return; }
+  xpix = (float)(xOrg + (xp/zp)*xScale);
+  ypix = (float)(yOrg + (yp/zp)*yScale);
+//  printf("-DBG-Proj3DC2GrC() %g %g %g -> %g %g %g -> %g %g %g -> (%g %g)\n", x,y,z,xc,yc,zc,xp,yp,zp,xp/zp,yp/zp);
+//  printf("-DBG- ... (%g %g %g - %g %g) %g %g - %g %g -> %g %g \n", xO,yO,zO, tO,fO, xOrg, yOrg,xScale,yScale ,xpix,ypix);
+}
+
+//++
+// Titre	Primitives de tracé 3D
+//--
+//++
+// void  DrawString3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0, char* s)
+//	Tracé de chaîne de caractères à la position "(x0,y0,z0)"
+// void  DrawOpaqueString3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0, char* s)
+//	Tracé de chaîne opaque à la position "(x0,y0,z0)"
+// void  DrawLine3D(PIGrCoord x1, PIGrCoord y1, PIGrCoord z1, -
+//                  PIGrCoord x2, PIGrCoord y2, PIGrCoord z2)
+//	Tracé d'une ligne entre les deux points "(x1,y1,z1)" et "(x2,y2,z2)"
+// void  DrawPolygon3D(PIGrCoord *x, PIGrCoord *y, PIGrCoord *z, int n)
+//	Tracé de contour de polygone - sommets définis par le tableau 
+//	"(x[i],y[i],z[i])" , "i=0..n-1"
+// void  DrawFPolygon3D(PIGrCoord *x, PIGrCoord *y, PIGrCoord *z, int n)
+//	Tracé de polygone - "(x[i],y[i],z[i])" , "i=0..n-1"
+// void  DrawMarker3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0)
+//	Tracé d'un signe (marker) au point "(x0,y0,z0)"
+// void  DrawMarkers3D(PIGrCoord *x, PIGrCoord *y, PIGrCoord *z, int n)
+//	Tracé de signes (marker) aux points "(x[i],y[i],z[i])" , "i=0..n-1"
+//--
+
+/* --Methode-- */
+void PIGraphic3D::DrawString3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0, const char* s)
+{
+  if (!mGrC) return;
+  float xf, yf;
+  Proj3DC2GrC(x0, y0, z0, xf, yf);
+  mGrC->DrawString(xf, yf, s);
+  return;
+}
+
+/* --Methode-- */
+void PIGraphic3D::DrawOpaqueString3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0, const char* s)
+{
+  if (!mGrC) return;
+  float xf, yf;
+  Proj3DC2GrC(x0, y0, z0, xf, yf);
+  mGrC->DrawOpaqueString(xf, yf, s);
+  return;
+}
+
+/* --Methode-- */
+void PIGraphic3D::DrawLine3D(PIGrCoord x1, PIGrCoord y1, PIGrCoord z1, 
+                             PIGrCoord x2, PIGrCoord y2, PIGrCoord z2)
+{
+  if (!mGrC) return;
+  float xf1, yf1, xf2, yf2;
+  Proj3DC2GrC(x1, y1, z1, xf1, yf1);
+  Proj3DC2GrC(x2, y2, z2, xf2, yf2);
+//  printf("-DBG-DrawLine3D() : %g %g %g -> %g %g | %g %g %g -> %g %g\n", 
+//         (float)x1, (float)y1, (float)z1, xf1, yf1, 
+//         (float)x2, (float)y2, (float)z2, xf2, yf2 );
+  mGrC->DrawLine(xf1, yf1, xf2, yf2);
+}
+
+#define NMXMULTP  30   // Pour multipoint sans new
+
+/* --Methode-- */
+void PIGraphic3D::DrawPolygon3D(PIGrCoord *x, PIGrCoord *y, PIGrCoord *z, int n)
+{
+  PIGrCoord xc[NMXMULTP], yc[NMXMULTP];
+  PIGrCoord *pxc, *pyc;
+  int i;
+  float xf, yf;
+ 
+  if (!mGrC) return;
+  if (n <= 0)  return;
+
+  if (n > NMXMULTP) { pxc = new PIGrCoord[n];  pyc = new PIGrCoord[n];  }
+  else { pxc = xc;  pyc = yc; }
+  for(i=0; i<n; i++) {
+    Proj3DC2GrC(x[i], y[i], z[i], xf, yf);
+    pxc[i] = xf;  pyc[i] = yf; 
+  }
+  mGrC->DrawPolygon(pxc, pyc, n, false);
+  if (n > NMXMULTP) { delete[] pxc;  delete[] pyc; }
+  return;
+}
+
+
+/* --Methode-- */
+void PIGraphic3D::DrawFPolygon3D(PIGrCoord *x, PIGrCoord *y, PIGrCoord *z, int n)
+{
+  PIGrCoord xc[NMXMULTP], yc[NMXMULTP];
+  PIGrCoord *pxc, *pyc;
+  int i;
+  float xf, yf;
+ 
+  if (!mGrC) return;
+  if (n <= 0)  return;
+
+  if (n > NMXMULTP) { pxc = new PIGrCoord[n];  pyc = new PIGrCoord[n];  }
+  else { pxc = xc;  pyc = yc; }
+  for(i=0; i<n; i++) {
+    Proj3DC2GrC(x[i], y[i], z[i], xf, yf);
+    pxc[i] = xf;  pyc[i] = yf; 
+  }
+  mGrC->DrawFPolygon(pxc, pyc, n, false);
+  if (n > NMXMULTP) { delete[] pxc;  delete[] pyc; }
+  return;
+}
+
+/* --Methode-- */
+void PIGraphic3D::DrawMarker3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0)
+{
+  if (!mGrC) return;
+  float xf, yf;
+  Proj3DC2GrC(x0, y0, z0, xf, yf);
+  mGrC->DrawMarker(xf, yf);
+  return;
+}
+
+/* --Methode-- */
+void PIGraphic3D::DrawMarkers3D(PIGrCoord *x, PIGrCoord *y, PIGrCoord *z, int n)
+{
+  PIGrCoord xc[NMXMULTP], yc[NMXMULTP];
+  PIGrCoord *pxc, *pyc;
+  int i;
+  float xf, yf;
+ 
+  if (!mGrC) return;
+  if (n <= 0)  return;
+
+  if (n > NMXMULTP) { pxc = new PIGrCoord[n];  pyc = new PIGrCoord[n]; }
+  else { pxc = xc;  pyc = yc; }
+  for(i=0; i<n; i++) {
+    Proj3DC2GrC(x[i], y[i], z[i], xf, yf);
+    pxc[i] = xf;  pyc[i] = yf; 
+  }
+  mGrC->DrawMarkers(pxc, pyc, n);
+  if (n > NMXMULTP) { delete[] pxc;  delete[] pyc; }
+  return;
+}
+
+
+//  Methode pour debugger 
 /* --Methode-- */
 void PIGraphic3D::PrintCS()
@@ -164,205 +478,2 @@
 printf("C+(0,1,1) -> %g %g %g -> %g %g \n", xp, yp, zp, xpix, ypix); 
 }
-
-/* --Methode-- */
-void PIGraphic3D::RotateObserver(float teta, float phi, float psi, bool rel)
-// Positionne l'observateur (la camera) de maniere a ce que la direction de 
-// visee soit tO=teta, pO=phi (rel=false) / tO+=teta pO+=phi (rel=true) 
-// en conservant le centre de champ fixe  
-{
-  if (rel) {
-    teta += tO;
-    phi += fO;
-    psi += pO;
-    }
-  while (teta < 0.)  teta += deuxpi;
-  while (teta > deuxpi)  teta -= deuxpi;
-  if (teta > M_PI)  { teta = M_PI-teta;  phi = phi+M_PI; }
-  float xo,yo,zo; 
-  zo = -cos((double)teta)*lCO+zC;
-  xo = -sin((double)teta)*cos((double)phi)*lCO+xC;
-  yo = -sin((double)teta)*sin((double)phi)*lCO+yC;
-  Set3DCS(xC,yC,zC, xo,yo,zo, daxO, dayO, dlCO, psi);
-}
-
-/* --Methode-- */
-void PIGraphic3D::RotateObject(float teta, float phi, bool rel)
-// Positionne l'objet (centre du champ) de maniere a ce que la direction de 
-// visee soit tO=teta, pO=phi (rel=false) / tO+=teta pO+=phi (rel=true) 
-// en conservant la position de l'observateur fixe.  
-{
-  if (rel) {
-    teta += tO;
-    phi += fO;
-    }
-  while (teta < 0.)  teta += deuxpi;
-  while (teta > deuxpi)  teta -= deuxpi;
-  if (teta > M_PI)  { teta = M_PI-teta;  phi = phi+M_PI; }
-  float xc,yc,zc; 
-  zc = cos((double)teta)*lCO+zO;
-  xc = sin((double)teta)*cos((double)phi)*lCO+xO;
-  yc = sin((double)teta)*sin((double)phi)*lCO+yO;
-  Set3DCS(xc,yc,zc, xO,yO,zO, daxO, dayO, dlCO, pO);
-}
-
-/* --Methode-- */
-void PIGraphic3D::ZoomInOut(float fco, float fdax, float fday, bool rel)
-{
-  if (fco < 0.001) fco = 1.;
-  if (fdax < 0.001) fdax = 1.;
-  if (fday < 0.001) fday = 1.;
-  double dl;
-  if (rel) {
-    dl = fco*lCO;  
-    fdax *= daxO;
-    fday *= dayO;
-  }
-  else dl = fco; 
-  float xo,yo,zo; 
-  if (dl < 1.e-5) dl = 1.e-5;
-  zo = zC-cos((double)tO)*dl;
-  xo = xC-sin((double)tO)*cos((double)fO)*dl;
-  yo = yC-sin((double)tO)*sin((double)fO)*dl;
-  Set3DCS(xC,yC,zC, xo,yo,zo, fdax, fday, dl, pO);
-//  Set3DCS_Obs(xo, yo, zo, tO, fO, pO, daxO*fda, dayO*fda, dl, dlCO);
-}
-
-/* --Methode-- */
-void PIGraphic3D::C3DC2ObsCS(float x, float y, float z, float& xp, float& yp, float& zp)
-{
-  double xc, yc, zc;
-  xc = x-xO;   yc = y-yO;    zc = z-zO;
-  xp = RE[0][0]*xc+RE[0][1]*yc+RE[0][2]*zc;
-  yp = -RE[1][0]*xc+RE[1][1]*yc+RE[1][2]*zc;  
-  zp = RE[2][0]*xc+RE[2][1]*yc+RE[2][2]*zc;
-}
-
-/* --Methode-- */
-void PIGraphic3D::Proj3DC2GrC(float x, float y, float z, float& xpix, float& ypix)
-{
-  double xc, yc, zc;
-  float xp, yp, zp;
-  xc = x-xO;   yc = y-yO;    zc = z-zO;
-  xp = RE[0][0]*xc+RE[0][1]*yc+RE[0][2]*zc;   
-  yp = RE[1][0]*xc+RE[1][1]*yc+RE[1][2]*zc;
-  zp = RE[2][0]*xc+RE[2][1]*yc+RE[2][2]*zc;
-  if ((zp>-1.e-6) && (zp < 1.e-6))   // Protection Divide/0
-    { xpix = ypix = 0.;   return; }
-  xpix = (float)(xOrg + (xp/zp)*xScale);
-  ypix = (float)(yOrg + (yp/zp)*yScale);
-//  printf("-DBG-Proj3DC2GrC() %g %g %g -> %g %g %g -> %g %g %g -> (%g %g)\n", x,y,z,xc,yc,zc,xp,yp,zp,xp/zp,yp/zp);
-//  printf("-DBG- ... (%g %g %g - %g %g) %g %g - %g %g -> %g %g \n", xO,yO,zO, tO,fO, xOrg, yOrg,xScale,yScale ,xpix,ypix);
-}
-
-/* --Methode-- */
-void PIGraphic3D::DrawString3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0, char* s)
-{
-  if (!mGrC) return;
-  float xf, yf;
-  Proj3DC2GrC(x0, y0, z0, xf, yf);
-  mGrC->DrawString(xf, yf, s);
-  return;
-}
-
-/* --Methode-- */
-void PIGraphic3D::DrawOpaqueString3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0, char* s)
-{
-  if (!mGrC) return;
-  float xf, yf;
-  Proj3DC2GrC(x0, y0, z0, xf, yf);
-  mGrC->DrawOpaqueString(xf, yf, s);
-  return;
-}
-
-/* --Methode-- */
-void PIGraphic3D::DrawLine3D(PIGrCoord x1, PIGrCoord y1, PIGrCoord z1, 
-                             PIGrCoord x2, PIGrCoord y2, PIGrCoord z2)
-{
-  if (!mGrC) return;
-  float xf1, yf1, xf2, yf2;
-  Proj3DC2GrC(x1, y1, z1, xf1, yf1);
-  Proj3DC2GrC(x2, y2, z2, xf2, yf2);
-//  printf("-DBG-DrawLine3D() : %g %g %g -> %g %g | %g %g %g -> %g %g\n", 
-//         (float)x1, (float)y1, (float)z1, xf1, yf1, 
-//         (float)x2, (float)y2, (float)z2, xf2, yf2 );
-  mGrC->DrawLine(xf1, yf1, xf2, yf2);
-}
-
-#define NMXMULTP  30   // Pour multipoint sans new
-
-/* --Methode-- */
-void PIGraphic3D::DrawPolygon3D(PIGrCoord *x, PIGrCoord *y, PIGrCoord *z, int n)
-{
-  PIGrCoord xc[NMXMULTP], yc[NMXMULTP];
-  PIGrCoord *pxc, *pyc;
-  int i;
-  float xf, yf;
- 
-  if (!mGrC) return;
-  if (n <= 0)  return;
-
-  if (n > NMXMULTP) { pxc = new PIGrCoord[n];  pyc = new PIGrCoord[n];  }
-  else { pxc = xc;  pyc = yc; }
-  for(i=0; i<n; i++) {
-    Proj3DC2GrC(x[i], y[i], z[i], xf, yf);
-    pxc[i] = xf;  pyc[i] = yf; 
-  }
-  mGrC->DrawPolygon(pxc, pyc, n, false);
-  if (n > NMXMULTP) { delete[] pxc;  delete[] pyc; }
-  return;
-}
-
-
-/* --Methode-- */
-void PIGraphic3D::DrawFPolygon3D(PIGrCoord *x, PIGrCoord *y, PIGrCoord *z, int n)
-{
-  PIGrCoord xc[NMXMULTP], yc[NMXMULTP];
-  PIGrCoord *pxc, *pyc;
-  int i;
-  float xf, yf;
- 
-  if (!mGrC) return;
-  if (n <= 0)  return;
-
-  if (n > NMXMULTP) { pxc = new PIGrCoord[n];  pyc = new PIGrCoord[n];  }
-  else { pxc = xc;  pyc = yc; }
-  for(i=0; i<n; i++) {
-    Proj3DC2GrC(x[i], y[i], z[i], xf, yf);
-    pxc[i] = xf;  pyc[i] = yf; 
-  }
-  mGrC->DrawFPolygon(pxc, pyc, n, false);
-  if (n > NMXMULTP) { delete[] pxc;  delete[] pyc; }
-  return;
-}
-
-/* --Methode-- */
-void PIGraphic3D::DrawMarker3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0)
-{
-  if (!mGrC) return;
-  float xf, yf;
-  Proj3DC2GrC(x0, y0, z0, xf, yf);
-  mGrC->DrawMarker(xf, yf);
-  return;
-}
-
-/* --Methode-- */
-void PIGraphic3D::DrawMarkers3D(PIGrCoord *x, PIGrCoord *y, PIGrCoord *z, int n)
-{
-  PIGrCoord xc[NMXMULTP], yc[NMXMULTP];
-  PIGrCoord *pxc, *pyc;
-  int i;
-  float xf, yf;
- 
-  if (!mGrC) return;
-  if (n <= 0)  return;
-
-  if (n > NMXMULTP) { pxc = new PIGrCoord[n];  pyc = new PIGrCoord[n]; }
-  else { pxc = xc;  pyc = yc; }
-  for(i=0; i<n; i++) {
-    Proj3DC2GrC(x[i], y[i], z[i], xf, yf);
-    pxc[i] = xf;  pyc[i] = yf; 
-  }
-  mGrC->DrawMarkers(pxc, pyc, n);
-  if (n > NMXMULTP) { delete[] pxc;  delete[] pyc; }
-  return;
-}
Index: trunk/SophyaPI/PI/pigraph3d.h
===================================================================
--- trunk/SophyaPI/PI/pigraph3d.h	(revision 157)
+++ trunk/SophyaPI/PI/pigraph3d.h	(revision 158)
@@ -1,2 +1,3 @@
+// This may look like C code, but it is really -*- C++ -*-
 // Module PI : Peida Interactive     PIGraphic3D
 // Trace graphiques 3D               R. Ansari  06/98
@@ -34,6 +35,6 @@
   virtual void       Proj3DC2GrC(float x, float y, float z, float& xpix, float& ypix);
   
-  virtual void       DrawString3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0, char* s);
-  virtual void       DrawOpaqueString3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0, char* s);
+  virtual void       DrawString3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0, const char* s);
+  virtual void       DrawOpaqueString3D(PIGrCoord x0, PIGrCoord y0, PIGrCoord z0, const char* s);
   virtual void       DrawLine3D(PIGrCoord x1, PIGrCoord y1, PIGrCoord z1, 
                                 PIGrCoord x2, PIGrCoord y2, PIGrCoord z2);
